VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
CXYPad Class Reference

`#include <cxypad.h>`

Inheritance diagram for CXYPad:

## Public Member Functions
| CXYPad (const CRect &size=CRect(0, 0, 0, 0))
void | setStopTrackingOnMouseExit (bool state)
bool | getStopTrackingOnMouseExit () const
void | setHandleBitmap (CBitmap *bitmap)
CBitmap * | getHandleBitmap () const
void | draw (CDrawContext *context) override
| called if the view should draw itself More...
void | drawBack (CDrawContext *pContext, CBitmap *newBack=nullptr) override
void | onMouseDownEvent (MouseDownEvent &event) override
| called when a mouse down event occurs More...
void | onMouseUpEvent (MouseUpEvent &event) override
| called when a mouse up event occurs More...
void | onMouseMoveEvent (MouseMoveEvent &event) override
| called when a mouse move event occurs More...
void | onMouseCancelEvent (MouseCancelEvent &event) override
| called when mouse tracking should be canceled More...
void | onMouseWheelEvent (MouseWheelEvent &event) override
| called when a mouse wheel event occurs More...
void | onKeyboardEvent (KeyboardEvent &event) override
| called when a keyboard event is dispatched to this view More...
void | setDefaultValue (float val) override
| set default value so that x and y default to val More...
void | setDefaultValues (float x, float y)
| set default value for x and y More...
Public Member Functions inherited from CParamDisplay
| CParamDisplay (const CRect &size, CBitmap *background=nullptr, int32_t style=0)
| CParamDisplay (const CParamDisplay &paramDisplay)
virtual void | setFont (CFontRef fontID)
const CFontRef | getFont () const
virtual void | setFontColor (CColor color)
CColor | getFontColor () const
virtual void | setBackColor (CColor color)
CColor | getBackColor () const
virtual void | setFrameColor (CColor color)
CColor | getFrameColor () const
virtual void | setShadowColor (CColor color)
CColor | getShadowColor () const
virtual void | setShadowTextOffset (const CPoint &offset)
CPoint | getShadowTextOffset () const
virtual void | setAntialias (bool state)
bool | getAntialias () const
virtual void | setHoriAlign (CHoriTxtAlign hAlign)
CHoriTxtAlign | getHoriAlign () const
virtual void | setTextInset (const CPoint &p)
CPoint | getTextInset () const
virtual void | setTextRotation (double angle)
double | getTextRotation () const
virtual void | setRoundRectRadius (const CCoord &radius)
CCoord | getRoundRectRadius () const
virtual void | setFrameWidth (const CCoord &width)
CCoord | getFrameWidth () const
void | setValueToStringFunction (const ValueToStringFunction &valueToStringFunc)
void | setValueToStringFunction (ValueToStringFunction &&valueToStringFunc)
void | setValueToStringFunction2 (const ValueToStringFunction2 &valueToStringFunc)
void | setValueToStringFunction2 (ValueToStringFunction2 &&valueToStringFunc)
virtual void | setStyle (int32_t val)
int32_t | getStyle () const
virtual void | setPrecision (uint8_t precision)
uint8_t | getPrecision () const
virtual void | setBackOffset (const CPoint &offset)
const CPoint & | getBackOffset () const
void | copyBackOffset ()
bool | getFocusPath (CGraphicsPath &outPath) override
| the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor() More...
bool | removed (CView *parent) override
| view is removed from parent view More...
CBaseObject * | newCopy () const override
Public Member Functions inherited from CControl
| CControl (const CRect &size, IControlListener *listener=nullptr, int32_t tag=0, CBitmap *pBackground=nullptr)
| CControl (const CControl &c)
virtual void | setValue (float val)
virtual float | getValue () const
virtual void | setValueNormalized (float val)
virtual float | getValueNormalized () const
virtual float | getMin () const
virtual float | getMax () const
float | getRange () const
virtual void | setOldValue (float val)
virtual float | getOldValue () const
virtual float | getDefaultValue () const
virtual void | bounceValue ()
virtual void | valueChanged ()
| notifies listener and dependent objects More...
virtual void | setTag (int32_t val)
virtual int32_t | getTag () const
virtual void | beginEdit ()
virtual void | endEdit ()
bool | isEditing () const
virtual IControlListener * | getListener () const
| get main listener More...
virtual void | setListener (IControlListener *l)
| set main listener More...
void | registerControlListener (IControlListener *listener)
| register a sub listener More...
void | unregisterControlListener (IControlListener *listener)
| unregister a sub listener More...
virtual void | setWheelInc (float val)
virtual float | getWheelInc () const
bool | isDirty () const override
| check if view is dirty More...
void | setDirty (bool val=true) override
| set the view to dirty so that it is redrawn in the next idle. More...
bool | drawFocusOnTop () override
| draw focus before view will be drawn or afterwards More...
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
virtual void | dispatchEvent (Event &event)
| dispatch an event More...
virtual void | onMouseEnterEvent (MouseEnterEvent &event)
| called when the mouse enters this view More...
virtual void | onMouseExitEvent (MouseExitEvent &event)
| called when the mouse leaves this view More...
virtual void | onZoomGestureEvent (ZoomGestureEvent &event)
| called when a zoom gesture event occurs More...
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view More...
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not More...
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse More...
CRect | getMouseableArea () const
| get the area in which the view reacts to the mouse More...
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| do not use any longer. More...
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| do not use any longer. More...
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| do not use any longer. More...
virtual CMouseEventResult | onMouseCancel ()
| do not use any longer. More...
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| do not use any longer. More...
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| do not use any longer. More...
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) final
virtual bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons)
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse More...
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const Event &event=noEvent())
| check if where hits this view More...
virtual bool | hitTest (const CPoint &where, const CButtonState &buttons)
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| start a drag operation More...
virtual SharedPointer< IDropTarget > | getDropTarget ()
| get the drag target for drag and drop handling More...
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target More...
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown More...
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus More...
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus More...
CCoord | getHeight () const
| get the height of the view More...
CCoord | getWidth () const
| get the width of the view More...
virtual void | setViewSize (const CRect &rect, bool invalid=true)
| set views size More...
const CRect & | getViewSize () const
| read only access to view size More...
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view More...
virtual void | parentSizeChanged ()
| notification that one of the views parent has changed its size More...
virtual CPoint & | frameToLocal (CPoint &point) const
| conversion from frame coordinates to local view coordinates More...
virtual CPoint & | localToFrame (CPoint &point) const
| conversion from local view coordinates to frame coordinates More...
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags More...
int32_t | getAutosizeFlags () const
| get autosize flags More...
virtual bool | sizeToFit ()
| resize view to optimal size More...
virtual void | looseFocus ()
| called if view should loose focus More...
virtual void | takeFocus ()
| called if view should take focus More...
virtual bool | wantsFocus () const
| check if view supports focus More...
virtual void | setWantsFocus (bool state)
| set focus support on/off More...
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute More...
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute More...
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute More...
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute More...
template<typename T >
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute More...
template<typename T >
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute More...
virtual void | setBackground (CBitmap *background)
| set the background image of this view More...
CBitmap * | getBackground () const
| get the background image of this view More...
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled More...
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled More...
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state. More...
virtual void | setTransparency (bool val)
| set views transparent state More...
bool | getTransparency () const
| get views transparent state More...
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view More...
float | getAlphaValue () const
| get alpha value More...
virtual bool | attached (CView *parent)
| view is attached to a parent view More...
bool | isAttached () const
| is view attached to a parentView More...
void | setSubviewState (bool state)
bool | isSubview () const
CView * | getParentView () const
| get parent view More...
CFrame * | getFrame () const
| get frame More...
virtual VSTGUIEditorInterface * | getEditor () const
| get editor More...
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc=nullptr, bool callDoneOnCancel=false)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewEventListener (IViewEventListener *listener)
void | unregisterViewEventListener (IViewEventListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform (bool ignoreFrame=false) const
| get the active global transform for this view More...
template<typename T >
T & | translateToGlobal (T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms More...
template<typename T >
T | translateToGlobal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms More...
template<typename T >
T & | translateToLocal (T &t, bool ignoreFrame=false) const
| translates a global coordinate to a local one using parent transforms More...
template<typename T >
T | translateToLocal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms More...
virtual CViewContainer * | asViewContainer ()
virtual const CViewContainer * | asViewContainer () const
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
void | beforeDelete () override
CBaseObject * | newCopy () const override
virtual void | drawRect (CDrawContext *pContext, const CRect &updateRect)
| called if the view should draw itself More...
virtual bool | checkUpdate (const CRect &updateRect) const
virtual void | invalidRect (const CRect &rect)
| mark rect as invalid More...
virtual void | invalid ()
| mark whole view as invalid More...
virtual void | setVisible (bool state)
| set visibility state More...
bool | isVisible () const
| get visibility state More...
virtual void | onIdle ()
| called on idle when view wants idle More...
void | setWantsIdle (bool state)
| enable/disable onIdle() callback More...
bool | wantsIdle () const
| returns if the view wants idle callback or not More...
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes More...
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes More...
void | setTooltipText (UTF8StringPtr text)
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexcept override=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0 More...
void | remember () override
| increase refcount More...
virtual int32_t | getNbReference () const
| get refcount More...
virtual void | forget ()=0
| decrease refcount and delete object if refcount == 0 More...
virtual void | remember ()=0
| increase refcount More...
Public Member Functions inherited from IFocusDrawing
virtual | ~IFocusDrawing () noexcept=default
virtual bool | drawFocusOnTop ()=0
| draw focus before view will be drawn or afterwards More...
virtual bool | getFocusPath (CGraphicsPath &outPath)=0
| the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor() More...

## Static Public Member Functions
static float | calculateValue (float x, float y)
static void | calculateXY (float value, float &x, float &y)

## Protected Member Functions
void | onMouseMove (MouseDownUpMoveEvent &event)
void | setMin (float val) override
void | setMax (float val) override
void | boundValues (float &x, float &y)
Protected Member Functions inherited from CParamDisplay
| ~CParamDisplay () noexcept override
virtual void | drawPlatformText (CDrawContext *pContext, const UTF8String &string)
virtual void | drawPlatformText (CDrawContext *pContext, const UTF8String &string, const CRect &size)
virtual void | drawStyleChanged ()
Protected Member Functions inherited from CControl
| ~CControl () noexcept override
Protected Member Functions inherited from CView
| ~CView () noexcept override
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)
Protected Member Functions inherited from CMouseWheelEditingSupport
void | invalidMouseWheelEditTimer (CControl *control)
void | onMouseWheelEditing (CControl *control)

## Protected Attributes
float | mouseStartValue
CPoint | mouseChangeStartPoint
CPoint | lastMouseChangePoint
bool | stopTrackingOnMouseExit
SharedPointer< CBitmap > | handle
Protected Attributes inherited from CParamDisplay
ValueToStringFunction2 | valueToStringFunction
CHoriTxtAlign | horiTxtAlign
int32_t | style
uint8_t | valuePrecision
CFontRef | fontID
CColor | fontColor
CColor | backColor
CColor | frameColor
CColor | shadowColor
CPoint | textInset
CPoint | shadowTextOffset {1., 1.}
CPoint | backOffset
CCoord | roundRectRadius
CCoord | frameWidth
double | textRotation
Protected Attributes inherited from CControl
IControlListener * | listener
int32_t | tag
float | value

## Additional Inherited Members
Public Types inherited from CParamDisplay
enum | Style { kShadowText = 1 << StyleShadowText , k3DIn = 1 << Style3DIn , k3DOut = 1 << Style3DOut , kNoTextStyle = 1 << StyleNoText , kNoDrawStyle = 1 << StyleNoDraw , kRoundRectStyle = 1 << StyleRoundRect , kNoFrame = 1 << StyleNoFrame }
using | ValueToStringUserData = CParamDisplay
using | ValueToStringFunction = std::function< bool(float value, char utf8String[256], CParamDisplay *display)>
using | ValueToStringFunction2 = std::function< bool(float value, std::string &result, CParamDisplay *display)>
Public Types inherited from CControl
using | CheckDefaultValueEventFuncT = bool(*)(CControl *, MouseDownEvent &)
using | CheckDefaultValueFuncT = bool(*)(CControl *, CButtonState)
Public Types inherited from CView
enum class | MouseListenerCall { MouseDown , MouseMoved , MouseUp , MouseCancel }
Static Public Attributes inherited from CControl
static CheckDefaultValueEventFuncT | CheckDefaultValueEventFunc
| Function to check if a mouse down event should reset the value to its default value for a control. More...
static int32_t | kZoomModifier = kShift
| zoom modifier key, per default is the shift key More...
static int32_t | kDefaultValueModifier = kControl
static CheckDefaultValueFuncT | CheckDefaultValueFunc
Static Public Attributes inherited from CView
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle. More...
static uint32_t | idleRate = 30
| global idle rate in Hz, defaults to 30 Hz More...
Protected Types inherited from CParamDisplay
enum | StyleEnum { StyleShadowText = 0 , Style3DIn , Style3DOut , StyleNoText , StyleNoDraw , StyleRoundRect , StyleNoFrame , StyleAntialias , LastStyle }
enum | StylePrivate { kAntialias = 1 << StyleAntialias }
Protected Types inherited from CView
enum | { kMouseEnabled = 1 << 0 , kTransparencyEnabled = 1 << 1 , kWantsFocus = 1 << 2 , kIsAttached = 1 << 3 , kVisible = 1 << 4 , kDirty = 1 << 5 , kWantsIdle = 1 << 6 , kIsSubview = 1 << 7 , kHasAlpha = 1 << 8 , kHasBackground = 1 << 9 , kHasDisabledBackground = 1 << 10 , kHasMouseableArea = 1 << 11 , kLastCViewFlag = 11 }
Static Protected Member Functions inherited from CControl
static int32_t | mapVstKeyModifier (int32_t vstModifier)

## Constructor & Destructor Documentation

## ◆ CXYPad()

CXYPad | ( | const CRect & | size = `CRect (0, 0, 0, 0)` | ) |
| explicit

## Member Function Documentation

## ◆ boundValues()

void boundValues | ( | float & | x,
|  | float & | y
| ) |  |
| protected

## ◆ calculateValue()

static float calculateValue | ( | float | x,
|  | float | y
| ) |  |
| inline static

## ◆ calculateXY()

static void calculateXY | ( | float | value,
|  | float & | x,
|  | float & | y
| ) |  |
| inline static

## ◆ draw()

void draw | ( | CDrawContext * | pContext | ) |
| override virtual

called if the view should draw itself

Parameters

  pContext | draw context in which to draw

Reimplemented from CParamDisplay.

## ◆ drawBack()

void drawBack | ( | CDrawContext * | pContext,
|  | CBitmap * | newBack = `nullptr`
| ) |  |
| override virtual

Reimplemented from CParamDisplay.

## ◆ getHandleBitmap()

CBitmap * getHandleBitmap | ( |  | ) | const

## ◆ getStopTrackingOnMouseExit()

bool getStopTrackingOnMouseExit | ( |  | ) | const
| inline

## ◆ onKeyboardEvent()

void onKeyboardEvent | ( | KeyboardEvent & | event | ) |
| override virtual

called when a keyboard event is dispatched to this view

This happens normally only if the view is the focus view.

Reimplemented from CView.

## ◆ onMouseCancelEvent()

void onMouseCancelEvent | ( | MouseCancelEvent & | event | ) |
| override virtual

called when mouse tracking should be canceled

Reimplemented from CView.

## ◆ onMouseDownEvent()

void onMouseDownEvent | ( | MouseDownEvent & | event | ) |
| override virtual

called when a mouse down event occurs

Reimplemented from CView.

## ◆ onMouseMove()

void onMouseMove | ( | MouseDownUpMoveEvent & | event | ) |
| protected

## ◆ onMouseMoveEvent()

void onMouseMoveEvent | ( | MouseMoveEvent & | event | ) |
| override virtual

called when a mouse move event occurs

Reimplemented from CView.

## ◆ onMouseUpEvent()

void onMouseUpEvent | ( | MouseUpEvent & | event | ) |
| override virtual

called when a mouse up event occurs

Reimplemented from CView.

## ◆ onMouseWheelEvent()

void onMouseWheelEvent | ( | MouseWheelEvent & | event | ) |
| override virtual

called when a mouse wheel event occurs

Reimplemented from CView.

## ◆ setDefaultValue()

void setDefaultValue | ( | float | val | ) |
| override virtual

set default value so that x and y default to val

Reimplemented from CControl.

## ◆ setDefaultValues()

void setDefaultValues | ( | float | x,
|  | float | y
| ) |  |

set default value for x and y

## ◆ setHandleBitmap()

void setHandleBitmap | ( | CBitmap * | bitmap | ) |

## ◆ setMax()

void setMax | ( | float | val | ) |
| inline override protected virtual

Reimplemented from CControl.

## ◆ setMin()

void setMin | ( | float | val | ) |
| inline override protected virtual

Reimplemented from CControl.

## ◆ setStopTrackingOnMouseExit()

void setStopTrackingOnMouseExit | ( | bool | state | ) |
| inline

## Member Data Documentation

## ◆ handle

SharedPointer<CBitmap> handle
| protected

## ◆ lastMouseChangePoint

CPoint lastMouseChangePoint
| protected

## ◆ mouseChangeStartPoint

CPoint mouseChangeStartPoint
| protected

## ◆ mouseStartValue

float mouseStartValue
| protected

## ◆ stopTrackingOnMouseExit

bool stopTrackingOnMouseExit
| protected

The documentation for this class was generated from the following files:

- cxypad.h
- cxypad.cpp